function CI = centroidIndex3(c1, c2)

%% check input data
if ( nargin ~=2 )
    error('Too few input data!\n');
end

%c1 = load(c1);
%c2 = load(c2);

%% CI
K1 = size(c1,1);
K2 = size(c2,1);
map12 = centroidsMapping(c1,c2); % mapping c1 centroids to c2
map21 = centroidsMapping(c2,c1); % mapping c1 centroids to c2
orphan2 = K2 - length(unique(map12));
orphan1 = K1 - length(unique(map21));

CI = max(orphan1, orphan2);

end % function centroidIndex

% mapping centroids of one clustering to another for Centroid Index
function mapx = centroidsMapping(c1,c2)

n1 = size(c1, 1); % number of centroids in clustering 1
n2 = size(c2, 1); % number of centroids in clustering 2

d = size(c1, 2); % dimensioanlity of data

mapx = ones(n1,1);
% nearest neighbor mapping
for i = 1:n1
    p1 = c1(i,:);
    k = 1;
    dmin = flintmax;   % bitmax
    for j = 1:n2
        p2 = c2(j,:);
        t = norm(p1-p2);
        if ( t < dmin )
            dmin = t;
            k = j;
        end
    end
    
    mapx(i) = k;
end

end % function mapCentroids

